/*
Copyright 2020 The KubeSphere Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

package v1alpha3

import (
	"testing"

	"github.com/stretchr/testify/assert"
)

func TestGetSupportedCredentialTypes(t *testing.T) {
	// test basic return
	types := GetSupportedCredentialTypes()
	assert.Equal(t, supportedCredentialTypes, types)

	// test unmodifiable
	// try to modify the types
	types = append(types, SecretTypeBasicAuth)
	// check if the return value is modified
	assert.NotEqual(t, types, GetSupportedCredentialTypes())
	assert.Equal(t, supportedCredentialTypes, GetSupportedCredentialTypes())
}
